package chapter5;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

import Jama.Matrix;

public class MultThreshold2_3Shamir {

	/**
	 * @param args
	 */
	
	// returns true if S_M is based on polynomial interpolation
	public static Boolean isShamir(double[][] M, double[][] V, double[][] F, int n){
		
		Matrix Fmatrix, Vmatrix, VF, Mtop2Matrix, Vtop2Matrix;
		double[][] Mtop2, Vtop2;
				
		Vmatrix = new Matrix(V);
				
		Mtop2 = new double[2][2];
		Vtop2 = new double[2][2];
		for (int i = 0; i < 2; i++){
			for (int j = 0; j < 2; j++){
				Mtop2[i][j] = M[i][j];
				Vtop2[i][j] = V[i][j];
			}
		}
		Mtop2Matrix = new Matrix(Mtop2);
		Vtop2Matrix = new Matrix(Vtop2);
		
		Fmatrix = MultThresholdLib.matrixMod(Vtop2Matrix.inverse().times(Mtop2Matrix),2,2,n);
		for (int i = 0; i < 2; i++){
			for (int j = 0; j < 2; j++){
				F[i][j] = Fmatrix.getArray()[i][j];
			}
		}
		
		VF = MultThresholdLib.matrixMod(Vmatrix.times(Fmatrix),3,2,n);
		if (MultThresholdLib.matrixEqual(M, VF.getArray(), 3, 2)){
			return true;
		}	
		else {
			return false;
		}
	}
	
	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		// TODO Auto-generated method stub
		
		double[][] M, F, N, r, c;
		double[] Chyp;
		double[][][] V;
		int Vindex, rindex, cindex, n, N3, N2, NV, multThresholdCtr, shamirCtr, homThresholdCtr, homShamirCtr;
		Boolean isShamir;
		
		FileWriter fstreamMultThreshold = new FileWriter("E:\\win_daten\\NordSecMob\\master thesis\\outMultThreshold2_3ZZn.txt");
        BufferedWriter outMultThreshold = new BufferedWriter(fstreamMultThreshold);
        FileWriter fstreamShamir = new FileWriter("E:\\win_daten\\NordSecMob\\master thesis\\outShamir2_3ZZn.txt");
        BufferedWriter outShamir = new BufferedWriter(fstreamShamir);
        FileWriter fstreamHomThreshold = new FileWriter("E:\\win_daten\\NordSecMob\\master thesis\\outHomThreshold2_3ZZn.txt");
        BufferedWriter outHomThreshold = new BufferedWriter(fstreamHomThreshold);
        FileWriter fstreamHomShamir = new FileWriter("E:\\win_daten\\NordSecMob\\master thesis\\outHomShamir2_3ZZn.txt");
        BufferedWriter outHomShamir = new BufferedWriter(fstreamHomShamir);
        
        multThresholdCtr = 0;
		shamirCtr = 0;
		homThresholdCtr = 0;
		homShamirCtr = 0;
		
		Scanner in = new Scanner(System.in);
		System.out.print("Enter n: ");
		n = in.nextInt();
		
		N3 = n*n*n;
		N2 = n*n;
		NV = n*(n-1)*(n-2);
		
		// create all Vandermonde matrices V over ZZ_n
		V = new double[NV][3][2];
		Vindex = 0;
		for (int i1 = 0; i1 < n; i1++){
			for (int i2 = 0; i2 < n; i2++){
				for (int i3 = 0; i3 < n; i3++){
					if ((i1 != i2)&&(i1 != i3)&&(i2 != i3)){
						V[Vindex][0][0] = 1;
						V[Vindex][1][0] = 1;
						V[Vindex][2][0] = 1;
						V[Vindex][0][1] = i1;
						V[Vindex][1][1] = i2;
						V[Vindex][2][1] = i3;
						Vindex++;
					}
				}
			}
		}
		
		// create C matrix
		F = new double[2][2];
		
		// create all possible 3-vectors r over ZZ_n
		r = new double[N3][3];
		rindex = 0;
		for (int i1 = 0; i1 < n; i1++){
			for (int i2 = 0; i2 < n; i2++){
				for (int i3 = 0; i3 < n; i3++){
					r[rindex][0] = i1;
					r[rindex][1] = i2;
					r[rindex][2] = i3;
					rindex++;
				}
			}
		}
		
		// create all possible 3-vectors c with c = (1 * *) over ZZ_n
		c = new double[N2][3];
		cindex = 0;
		for (int i1 = 0; i1 < n; i1++){
			for (int i2 = 0; i2 < n; i2++){
				c[cindex][0] = 1;
				c[cindex][1] = i1;
				c[cindex][2] = i2;
				cindex++;
			}
		}
		
		M = new double[3][2];
		M[0][0] = 0;
		M[0][1] = 1;
		M[1][0] = 1;
		M[1][1] = 0;
		M[2][0] = 1;
		M[2][1] = 0;
		
		// create all 3x2 matrices M over ZZ_n with M = c*(1||(I||C))
		Chyp = new double[2];
		for (int i1 = 1; i1 < n; i1++){
			for (int i2 = 1; i2 < n; i2++){
				Chyp[0] = i1;
				Chyp[1] = i2;
											
				if(MultThresholdLib.isHypInv1(Chyp,2,n)){
					M[1][1] = Chyp[0];
					M[2][1] = Chyp[1];
					
					if (MultThresholdLib.isThreshold(M,3,2,n)&&(MultThresholdLib.isMult(M,r,3,2,n))){
						for (int k = 0; k < N2; k++){
							if (MultThresholdLib.no_zeroelts(c[k], 3) == 0){
								N = MultThresholdLib.starVM(c[k],M,3,2,n);
								
								MultThresholdLib.printMatrix(N,3,2,outMultThreshold);
								outMultThreshold.newLine();
								multThresholdCtr++;
								
								isShamir = false;
								int i;
								for (i = 0; i < NV; i++){
									if (isShamir(N,V[i],F,n)){
										MultThresholdLib.printMatrix(N,3,2,outShamir);
										outShamir.write(" = ");
										outShamir.newLine();
										MultThresholdLib.printMatrix(V[i],3,2,outShamir);
										outShamir.write(" * ");
										outShamir.newLine();
										MultThresholdLib.printMatrix(F,2,2,outShamir);
										outShamir.newLine();
										shamirCtr++;
										isShamir = true;
										break;
									}
								}
								if (MultThresholdLib.isHom(N,r,3,2,n)){
									MultThresholdLib.printMatrix(N,3,2,outHomThreshold);
									outHomThreshold.newLine();
									homThresholdCtr++;
									if (isShamir){
										MultThresholdLib.printMatrix(N,3,2,outHomShamir);
										outHomShamir.write(" = ");
										outHomShamir.newLine();
										MultThresholdLib.printMatrix(V[i],3,2,outHomShamir);
										outHomShamir.write(" * ");
										outHomShamir.newLine();
										MultThresholdLib.printMatrix(F,2,2,outHomShamir);
										outHomShamir.newLine();
										homShamirCtr++;
									}
								}
							}							
						}
					}
				}
			}
		}
			
		outMultThreshold.close();
		outShamir.close();
		outHomThreshold.close();
		outHomShamir.close();
		System.out.println("Number of 3x2 2-out-of-3 multiplicative threshold LSSSs over ZZ_"+n+": " + multThresholdCtr);
		System.out.println("Number of 3x2 2-out-of-3 multiplicative threshold LSSSs based on polynomial interpolation over ZZ_"+n+": " + shamirCtr);
		System.out.println("Number of 3x2 2-out-of-3 homomorphic threshold LSSSs over ZZ_"+n+": " + homThresholdCtr);
		System.out.println("Number of 3x2 2-out-of-3 homomorphic threshold LSSSs based on polynomial interpolation over ZZ_"+n+": " + homShamirCtr);
	}

}
