package chapter5;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

import Jama.Matrix;

public class MultThreshold3_5Shamir {

	/**
	 * @param args
	 */
	
	// returns true if S_M is based on polynomial interpolation
	public static Boolean isShamir(double[][] M, double[][] V, double[][] F, int n){
		
		Matrix Fmatrix, Vmatrix, VF, Mtop3Matrix, Vtop3Matrix;
		double[][] Mtop3, Vtop3;
				
		Vmatrix = new Matrix(V);
				
		Mtop3 = new double[3][3];
		Vtop3 = new double[3][3];
		for (int i = 0; i < 3; i++){
			for (int j = 0; j < 3; j++){
				Mtop3[i][j] = M[i][j];
				Vtop3[i][j] = V[i][j];
			}
		}
		Mtop3Matrix = new Matrix(Mtop3);
		Vtop3Matrix = new Matrix(Vtop3);
		
		Fmatrix = MultThresholdLib.matrixMod(Vtop3Matrix.inverse().times(Mtop3Matrix),3,3,n);
		for (int i = 0; i < 3; i++){
			for (int j = 0; j < 3; j++){
				F[i][j] = Fmatrix.getArray()[i][j];
			}
		}
		
		VF = MultThresholdLib.matrixMod(Vmatrix.times(Fmatrix),5,3,n);
		if (MultThresholdLib.matrixEqual(M, VF.getArray(),5,3)){
			return true;
		}
		else {
			return false;
		}
	}
	
	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		// TODO Auto-generated method stub
		
		double[][] M, F, Chyp, r, c, N;
		double[][][] V;
		int Vindex, rindex, cindex, n, N5, N3, NV, multThresholdCtr, shamirCtr, homThresholdCtr, homShamirCtr;
		Boolean isShamir;
		
		FileWriter fstreamMultThreshold = new FileWriter("E:\\win_daten\\NordSecMob\\master thesis\\outMultThreshold3_5ZZn.txt");
        BufferedWriter outMultThreshold = new BufferedWriter(fstreamMultThreshold);
        FileWriter fstreamShamir = new FileWriter("E:\\win_daten\\NordSecMob\\master thesis\\outShamir3_5ZZn.txt");
        BufferedWriter outShamir = new BufferedWriter(fstreamShamir);
        FileWriter fstreamHomThreshold = new FileWriter("E:\\win_daten\\NordSecMob\\master thesis\\outHomThreshold3_5ZZn.txt");
        BufferedWriter outHomThreshold = new BufferedWriter(fstreamHomThreshold);
        FileWriter fstreamHomShamir = new FileWriter("E:\\win_daten\\NordSecMob\\master thesis\\outHomShamir3_5ZZn.txt");
        BufferedWriter outHomShamir = new BufferedWriter(fstreamHomShamir);
        
        multThresholdCtr = 0;
		shamirCtr = 0;
		homThresholdCtr = 0;
		homShamirCtr = 0;
		
		Scanner in = new Scanner(System.in);
		System.out.print("Enter n: ");
		n = in.nextInt();
		
		N5 = n*n*n*n*n;
		N3 = n*n*n;
		NV = n*(n-1)*(n-2)*(n-3)*(n-4);
		
		// create all Vandermonde matrices V over ZZ_n
		V = new double[NV][5][3];
		Vindex = 0;
		for (int i1 = 0; i1 < n; i1++){
			for (int i2 = 0; i2 < n; i2++){
				for (int i3 = 0; i3 < n; i3++){
					for (int i4 = 0; i4 < n; i4++){
						for (int i5 = 0; i5 < n; i5++){
							if ((i1 != i2)&&(i1 != i3)&&(i1 != i4)&&(i1 != i5)&&(i2 != i3)&&(i2 != i4)&&(i2 != i5)&&(i3 != i4)&&(i3 != i5)&&(i4 != i5)){
								V[Vindex][0][0] = 1;
								V[Vindex][1][0] = 1;
								V[Vindex][2][0] = 1;
								V[Vindex][3][0] = 1;
								V[Vindex][4][0] = 1;
								V[Vindex][0][1] = i1;
								V[Vindex][1][1] = i2;
								V[Vindex][2][1] = i3;
								V[Vindex][3][1] = i4;
								V[Vindex][4][1] = i5;
								V[Vindex][0][2] = MultThresholdLib.mod(i1*i1,n);
								V[Vindex][1][2] = MultThresholdLib.mod(i2*i2,n);
								V[Vindex][2][2] = MultThresholdLib.mod(i3*i3,n);
								V[Vindex][3][2] = MultThresholdLib.mod(i4*i4,n);
								V[Vindex][4][2] = MultThresholdLib.mod(i5*i5,n);
								Vindex++;
							}
						}
					}
				}
			}
		}
		
		// create C matrix
		F = new double[3][3];
		
		// create all possible 5-vectors r over ZZ_n
		r = new double[N5][5];
		rindex = 0;
		for (int i1 = 0; i1 < n; i1++){
			for (int i2 = 0; i2 < n; i2++){
				for (int i3 = 0; i3 < n; i3++){
					for (int i4 = 0; i4 < n; i4++){
						for (int i5 = 0; i5 < n; i5++){
							r[rindex][0] = i1;
							r[rindex][1] = i2;
							r[rindex][2] = i3;
							r[rindex][3] = i4;
							r[rindex][4] = i5;
							rindex++;
						}
					}
				}
			}
		}
		
		// create all possible 5-vectors c with c = (1 1 * * *) over ZZ_n
		c = new double[N3][5];
		cindex = 0;
		for (int i1 = 0; i1 < n; i1++){
			for (int i2 = 0; i2 < n; i2++){
				for (int i3 = 0; i3 < n; i3++){
					c[cindex][0] = 1;
					c[cindex][1] = 1;
					c[cindex][2] = i1;
					c[cindex][3] = i2;
					c[cindex][4] = i3;
					cindex++;
				}
			}
		}
		
		M = new double[5][3];
		M[0][0] = 0;
		M[0][1] = 1;
		M[0][2] = 0;
		M[1][0] = 0;
		M[1][1] = 0;
		M[1][2] = 1;
		M[2][0] = 1;
		M[2][1] = 0;
		M[2][2] = 0;
		M[3][0] = 1;
		M[3][1] = 0;
		M[3][2] = 0;
		M[4][0] = 1;
		M[4][1] = 0;
		M[4][2] = 0;
		
		// create all 5x3 matrices M over ZZ_n with M = c*(1||(I||C))
		Chyp = new double[3][2];
		for (int i1 = 1; i1 < n; i1++){
			for (int i2 = 1; i2 < n; i2++){
				for (int i3 = 1; i3 < n; i3++){
					for (int i4 = 1; i4 < n; i4++){
						for (int i5 = 1; i5 < n; i5++){
							for (int i6 = 1; i6 < n; i6++){
								Chyp[0][0] = i1;
								Chyp[0][1] = i2;
								Chyp[1][0] = i3;
								Chyp[1][1] = i4;
								Chyp[2][0] = i5;
								Chyp[2][1] = i6;
								
								if(MultThresholdLib.isHypInv2(Chyp,3,n)){
								
									M[2][1] = Chyp[0][0];
									M[2][2] = Chyp[0][1];
									M[3][1] = Chyp[1][0];
									M[3][2] = Chyp[1][1];
									M[4][1] = Chyp[2][0];
									M[4][2] = Chyp[2][1];
								
									if (MultThresholdLib.isThreshold(M,5,3,n)&&(MultThresholdLib.isMult(M,r,5,3,n))){
										
										for (int k = 0; k < N3; k++){
											if (MultThresholdLib.no_zeroelts(c[k], 5) == 0){
												N = MultThresholdLib.starVM(c[k],M,5,3,n);
												
												MultThresholdLib.printMatrix(N,5,3,outMultThreshold);
												outMultThreshold.newLine();
												multThresholdCtr++;
												
												isShamir = false;
												int i;
												for (i = 0; i < NV; i++){
													if (isShamir(N,V[i],F,n)){
														MultThresholdLib.printMatrix(N,5,3,outShamir);
														outShamir.write(" = ");
														outShamir.newLine();
														MultThresholdLib.printMatrix(V[i],5,3,outShamir);
														outShamir.write(" * ");
														outShamir.newLine();
														MultThresholdLib.printMatrix(F,3,3,outShamir);
														outShamir.newLine();
														shamirCtr++;
														isShamir = true;
														break;
													}
												}
												if (MultThresholdLib.isHom(N,r,5,3,n)){
													MultThresholdLib.printMatrix(N,5,3,outHomThreshold);
													outHomThreshold.newLine();
													homThresholdCtr++;
													if (isShamir){
														MultThresholdLib.printMatrix(N,5,3,outHomShamir);
														outHomShamir.write(" = ");
														outHomShamir.newLine();
														MultThresholdLib.printMatrix(V[i],5,3,outHomShamir);
														outHomShamir.write(" * ");
														outHomShamir.newLine();
														MultThresholdLib.printMatrix(F,3,3,outHomShamir);
														outHomShamir.newLine();
														homShamirCtr++;
													}
												}
											}
										}										
									}
								}
							}
						}
					}
				}
			}
		}
			
		outMultThreshold.close();
		outShamir.close();
		outHomThreshold.close();
		outHomShamir.close();
		System.out.println("Number of 5x3 3-out-of-5 multiplicative threshold LSSSs over ZZ_"+n+": " + multThresholdCtr);
		System.out.println("Number of 5x3 3-out-of-5 multiplicative threshold LSSSs based on polynomial interpolation over ZZ_"+n+": " + shamirCtr);
		System.out.println("Number of 5x3 3-out-of-5 homomorphic threshold LSSSs over ZZ_"+n+": " + homThresholdCtr);
		System.out.println("Number of 5x3 3-out-of-5 homomorphic threshold LSSSs based on polynomial interpolation over ZZ_"+n+": " + homShamirCtr);
	}

}
